<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2006 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: lib-view-main.inc.php 4747 2006-04-26 17:04:32Z scott@m3.net $
*/

//  all these calls are made from delivery, hence they must not use any Data Access layers

require_once MAX_PATH . '/lib/max/Admin/Preferences.php';
require_once MAX_PATH . '/lib/max/other/delivery.php';
require_once MAX_PATH . '/lib/max/other/lib-io.inc.php';
require_once MAX_PATH . '/lib/max/Admin_DA.php';
require_once MAX_PATH . '/lib/max/Delivery/cookie.php';
require_once MAX_PATH . '/lib/max/Delivery/log.php';

// Seed the random number generator
//mt_srand((double)microtime() * 1000000);
mt_srand(floor((isset($n) && strlen($n) > 5 ? hexdec($n[0].$n[2].$n[3].$n[4].$n[5]): 1000000) * (double)microtime()));

/*-------------------------------------------------------*/
/* Create the HTML needed to display the banner          */
/*-------------------------------------------------------*/

function view_raw($what, $target = '', $source = '', $withtext = 0, $context = 0, $richmedia = true, $ct0 = '', $loc = '', $referer = '')
{
    $conf = $GLOBALS['_MAX']['CONF'];
    global $phpAds_followedChain;
    // Store the original zone, campaign or banner IDs for later use
    if (substr($what,0,5) == 'zone:') {
		$originalZoneId = intval(substr($what,5));
    } elseif (substr($what,0,11) == 'campaignid:') {
        $originalCampaignId = intval(substr($what,11));
    } elseif (substr($what,0,9) == 'bannerid:') {
        $originalBannerId = intval(substr($what,9));
    }
    $userid = MAX_cookieGetUniqueViewerID();
    MAX_cookieSet($conf['var']['viewerId'], $userid, time()+365*24*60*60);
    $outputbuffer = '';
    // Set flag
    $found = false;
    // Reset followed zone chain
    $phpAds_followedChain = array();
    $GLOBALS['_MAX']['adChain'] = array();

    $first = true;
    global $g_append, $g_prepend;
    $g_append = '';
    $g_prepend = '';
    while (($what != '') && $found == false) {
		// Get first part, store second part
		$ix = strpos($what, ',');
		if ($ix === false) {
			$remaining = '';
		} else {
			$remaining = substr($what, $ix+1);
			$what = substr($what, 0, $ix);
		}
        if (substr($what,0,5) == 'zone:') {
			$zoneId  = intval(substr($what,5));
            $row = MAX_fetchBannerZone($zoneId, $context, $source, $richmedia);
        } else {
            $row = MAX_fetchBannerDirect($what, $context, $source, $richmedia);
        }
        if (is_array($row) && empty($row['default'])) {
            // Log the ad request
            if ($conf['logging']['adRequests']) {
                MAX_logAdRequest($userid, $row['bannerid'], null, $row['zoneid']);
            }
            if ($row['adserver'] == 'max' && preg_match("#{$conf['webpath']['delivery']}.*zoneid=([0-9]+)#", $row['htmltemplate'], $matches)) {
                // The ad selected was a Max HTML ad on the same server... do internal redirecty stuff
                $GLOBALS['_MAX']['adChain'][] = $row;
                $found = false;
                $what = "zone:{$matches[1]}";
            } else {
                $found = true;
            }
        } else {
          $what  = $remaining;
        }
    }

    // Return the banner information
    if ($found) {
        $zoneId = empty($row['zoneid']) ? 0 : $row['zoneid'];
        $outputbuffer = MAX_buildBannerHtml($row, $zoneId, $source, $target, $ct0, $withtext, true, true, $richmedia, $loc, $referer, $context);
        $output = array('html'       => $outputbuffer,
                     'bannerid'   => $row['bannerid'],
                     'contenttype'=> $row['contenttype'],
                     'alt'        => $row['alt'],
                     'width'      => $row['width'],
                     'height'     => $row['height'],
                     'url'        => $row['url'],
                     'campaignid' => $row['campaignid'],
                    );
         $output['context'] = (is_array($row['zone_companion']) && (count($row['zone_companion'])) > 0) ? _buildCompanionContext($row, $context) : '';
         return $output;
    } else {
        // No banner found
        if (!empty($row['default'])) {
            // Return the default banner
            if (empty($target)) {
                $target = '_blank';  // Default
            }
            $outputbuffer = $g_prepend . '<a href=\'' . $row['default_banner_dest'] . '\' target=\'' .
                            $target . '\'><img src=\'' . $row['default_banner_url'] .
                            '\' border=\'0\' alt=\'\'></a>' . $g_append;
            return array('html' => $outputbuffer, 'bannerid' => '' );
        } else {
            // No default banner was returned, return no banner
            $outputbuffer = $g_prepend . $g_append;
            return array('html' => $outputbuffer, 'bannerid' => '' );
        }
    }
}

function MAX_buildBannerHtml($aBanner, $zoneId=0, $source='', $target='', $ct0='', $withText=false, $logClick=true, $logView=true, $richMedia=true, $loc='', $referer='', $noFileUrl=false)
{
    $code = '';
    switch ($aBanner['contenttype']) {
        case 'gif'  :
        case 'jpeg' :
        case 'png'  :
            $code = _buildBannerCodeImage($aBanner, $zoneId, $source, $ct0, $withText, $logClick, $logView, false, $richMedia, $loc, $referer);
            break;
        case 'swf'  :
            if ($richMedia) {
                $code = _buildBannerCodeFlash($aBanner, $zoneId, $source, $ct0, $withText, $logClick, $logView, $loc, $referer, $noFileUrl);
            } else { $code = _buildBannerCodeImage($aBanner, $zoneId, $source, $ct0, $withText, $logClick, $logView, true, $richMedia, $loc, $referer); }
            break;
        case 'txt'  :
            $code = _buildBannerCodeText($aBanner, $zoneId, $source, $ct0, $withText, $logClick, $logView, false, $loc, $referer);
            break;
        case 'mov'  :
            $code = _buildBannerCodeQuicktime($aBanner, $zoneId, $source, $ct0, $withText, $logClick, $logView, $loc, $referer);
            break;
        default :
            switch ($aBanner['type']) {
                case 'html' :
                    $code = _buildBannerCodeHtml($aBanner, $zoneId, $source, $ct0, $withText, $logClick, $logView, false, $loc, $referer);
                    break;
                case 'url' : // External banner without a recognised content type - assume image...
                    $code = _buildBannerCodeImage($aBanner, $zoneId, $source, $ct0, $withText, $logClick, $logView, false, $richMedia, $loc, $referer);
                    break;
                case 'txt' :
                    $code = _buildBannerCodeText($aBanner, $zoneId, $source, $ct0, $withText, $logClick, $logView, false, $loc, $referer);
            }
            break;
    }
    // Transform any code
    $conf = $GLOBALS['_MAX']['CONF'];
    // Get the target
    if (empty($target))
        $target = !empty($aBanner['target']) ? $aBanner['target'] : '_blank';
    // Get a timestamp
    list($usec, $sec) = explode(' ', microtime());
    $time = (float)$usec + (float)$sec;
    // Get a random number
    $random = substr(md5(uniqid($time, true)), 0, 10);
    global $cookie_random;  // Temporary fix to get doubleclick tracking working (Bug # 88)
    $cookie_random = $random;
    // Get the click URL
    $clickUrl = _buildClickUrl($aBanner, $zoneId, $source, urlencode($ct0), $logClick, true);
    $urlPrefix = _getDeliveryUrl($conf['file']['click']);
    $code = str_replace('{clickurl}', $clickUrl, $code);  // This step needs to be done separately because {clickurl} can contain {random}...
    if (strpos($code, '{logurl}') !== false) {
        $logUrl = _buildLogURL($aBanner, $zoneId, $source, $loc, $referer, '&');
        $code = str_replace('{logurl}', $logUrl, $code);  // This step needs to be done separately because {logurl} does contain {random}...
    }
    if (strpos($code, '{logurl_enc}') !== false) {
        $logUrl_enc = urlencode(_buildLogURL($aBanner, $zoneId, $source, $loc, $referer, '&'));
        $code = str_replace('{logurl_enc}', $logUrl_enc, $code);  // This step needs to be done separately because {logurl} does contain {random}...
    }
    if (strpos($code, '{clickurlparams}')) {
        $maxparams = _buildParams($aBanner, $zoneId, $source, urlencode($ct0), $logClick, true);
        $code = str_replace('{clickurlparams}', $maxparams, $code);  // This step needs to be done separately because {clickurlparams} does contain {random}...
    }

    $search = array('{timestamp}','{random}','{target}','{url_prefix}','{bannerid}','{zoneid}','{source}');
    $replace = array($time, $random, $target, $urlPrefix, $aBanner['bannerid'], $zoneId, $source);

    preg_match_all('#{(.*?)}#', $code, $macros);
    for ($i=0;$i<count($macros[1]);$i++) {
        if (!in_array($macros[0][$i], $search) && isset($_REQUEST[$macros[1][$i]])) {
            $search[] = $macros[0][$i];
            $replace[] = urlencode($_REQUEST[$macros[1][$i]]);
        }
    }
    $code = str_replace($search, $replace, $code);
    return $code;
}

function _buildBannerCodeImage($aBanner, $zoneId=0, $source='', $ct0='', $withText=false, $logClick=true, $logView=true, $useAlt=false, $richMedia=true, $loc, $referer, $useAppend=true)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    if (!$richMedia) {
        return _buildFileUrl($aBanner, $useAlt, '{random}');
    }
    $prepend = (!empty($aBanner['prepend']) && $useAppend) ? $aBanner['prepend'] : '';
    $append = (!empty($aBanner['append']) && $useAppend) ? $aBanner['append'] : '';
    // Create the anchor tag..
    $clickUrl = _buildClickUrl($aBanner, $zoneId, $source, $ct0, $logClick);
    if (!empty($clickUrl)) {  // There is a link
        $status = !empty($aBanner['status']) ? " onMouseOver=\"self.status='{$aBanner['status']}'; return true;\" onMouseOut=\"self.status=''; return true;\"" : '';
        //$target = !empty($aBanner['target']) ? $aBanner['target'] : '_blank';
        $clickTag = "<a href='$clickUrl' target='{target}'$status>";
        $clickTagEnd = '</a>';
    } else {
        $clickTag = '';
        $clickTagEnd = '';
    }
    // Create the image tag..
    $imageUrl = _buildFileUrl($aBanner, $useAlt);
    if (!empty($imageUrl)) {
        $imgStatus = empty($clickTag) ? $status : '';
        $width = !empty($aBanner['width']) ? $aBanner['width'] : 0;
        $height = !empty($aBanner['height']) ? $aBanner['height'] : 0;
        $alt = !empty($aBanner['alt']) ? $aBanner['alt'] : '';
        $imageTag = "$clickTag<img src='$imageUrl' width='$width' height='$height' alt='$alt' title='$alt' border='0'$imgStatus>$clickTagEnd";
    } else {
        $imageTag = '';
    }
    // Get the text below the banner
    $bannerText = $withText && !empty($aBanner['bannertext']) ? "<br />$clickTag{$aBanner['bannertext']}$clickTagEnd" : '';
    // Get the image beacon...
    $beaconTag = ($logView && $conf['logging']['adImpressions']) ? _buildImageBeacon($aBanner, $zoneId, $source, $loc, $referer) : '';
    return $prepend . $imageTag . $bannerText . $beaconTag . $append;
}

function _buildBannerCodeFlash($aBanner, $zoneId=0, $source='', $ct0='', $withText=false, $logClick=true, $logView=true, $loc, $referer, $noFileUrl = false)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $prepend = !empty($aBanner['prepend']) ? $aBanner['prepend'] : '';
    $append = !empty($aBanner['append']) ? $aBanner['append'] : '';
    $width = !empty($aBanner['width']) ? $aBanner['width'] : 0;
    $height = !empty($aBanner['height']) ? $aBanner['height'] : 0;
    $pluginVersion = !empty($aBanner['pluginversion']) ? $aBanner['pluginversion'] : '4';
    // $imageUrlPrefix = ($_SERVER['SERVER_PORT'] == $conf['max']['sslPort']) ? $conf['type_web_ssl_url'] : $conf['type_web_url'];
    $fileName = !empty($aBanner['filename']) ? $aBanner['filename'] : '';
    $altImageAdCode = !empty($aBanner['alt_filename']) ? _buildBannerCodeImage($aBanner, $zoneId, $source, $ct0, false, $logClick, false, true, true, $loc, $referer, false) : '';
    // Create the anchor tag..
    $clickUrl = _buildClickUrl($aBanner, $zoneId, $source, $ct0, $logClick);
    if (!empty($clickUrl)) {  // There is a link
        $status = !empty($aBanner['status']) ? " onMouseOver=\"self.status='{$aBanner['status']}'; return true;\" onMouseOut=\"self.status=''; return true;\"" : '';
        $target = !empty($aBanner['target']) ? $aBanner['target'] : '_blank';
        $swfParams = 'clickTARGET='.$target.'&clickTAG=' . $clickUrl;
        $clickTag = "<a href='$clickUrl' target='$target'$status>";
        $clickTagEnd = '</a>';
    } else {
        $swfParams = '';
        $clickTag = '';
        $clickTagEnd = '';
    }
    if ($noFileUrl) {
        $aBanner['type'] = "url";
    }
    $fileUrl = _buildFileUrl($aBanner, false, $swfParams);
    $protocol = ($_SERVER['SERVER_PORT'] == $conf['max']['sslPort']) ? "https" : "http";
    $rnd = md5(microtime());
    $code = "
<div id='m3_$rnd'>$altImageAdCode</div>
<script type='text/javascript'>
   var fo = new FlashObject('$fileUrl', 'mymovie', '$width', '$height', '$pluginVersion');
   //fo.addParam('wmode','transparent');
   fo.write('m3_$rnd');
</script>";
    $bannerText = $withText && !empty($aBanner['bannertext']) ? "<br />{$clickTag}{$aBanner['bannertext']}{$clickTagEnd}" : '';
    // Get the image beacon...
    $beaconTag = ($logView && $conf['logging']['adImpressions']) ? _buildImageBeacon($aBanner, $zoneId, $source, $loc, $referer) : '';
    return "{$prepend}{$code}{$bannerText}{$beaconTag}{$append}";
}

function _buildBannerCodeQuicktime($aBanner, $zoneId=0, $source='', $ct0='', $withText=false, $logClick=true, $logView=true, $loc, $referer)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $prepend = !empty($aBanner['prepend']) ? $aBanner['prepend'] : '';
    $append = !empty($aBanner['append']) ? $aBanner['append'] : '';
    $width = !empty($aBanner['width']) ? $aBanner['width'] : 0;
    $height = !empty($aBanner['height']) ? $aBanner['height'] : 0;
    $pluginVersion = !empty($aBanner['pluginversion']) ? $aBanner['pluginversion'] : '4';
    // $imageUrlPrefix = ($_SERVER['SERVER_PORT'] == $conf['max']['sslPort']) ? $conf['type_web_ssl_url'] : $conf['type_web_url'];
    $fileName = !empty($aBanner['filename']) ? $aBanner['filename'] : '';
    $altImageBannercode = _buildBannerCodeImage($aBanner, $zoneId, $source, $ct0, false, $logClick, false, true, true, $loc, $referer);
    // Create the anchor tag..
    $clickTag = _buildClickUrl($aBanner, $source, $ct0, $logClick);
    if (!empty($clickTag)) {  // There is a link
        $status = !empty($aBanner['status']) ? " onMouseOver=\"self.status='{$aBanner['status']}'; return true;\" onMouseOut=\"self.status=''; return true;\"" : '';
        $target = !empty($aBanner['target']) ? $aBanner['target'] : '_blank';
        $swfParams = 'clickTAG=' . $clickTag;
        $anchor = "<a href='$clickTag' target='$target'$status>";
        $anchorEnd = '</a>';
    } else {
        $swfParams = '';
        $anchor = '';
        $anchorEnd = '';
    }
    $clickTag = _buildClickUrl($aBanner, $source, $ct0, $logClick);
    $fileUrl = _buildFileUrl($aBanner, false, $swfParams);
    $code = "
<object classid='clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B' codebase='http://www.apple.com/qtactivex/qtplugin.cab' width='$width' height='$height'>
<param name='src' value='$fileUrl'>
<param name='controller' value='false'>
<param name='autoplay' value='true'>
<embed src='$fileUrl' controller='false' autoplay='true' width='$width' height='$height' pluginspace='http://www.apple.com/quicktime/download/'></embed>
<noembed>$altImageBannercode</noembed>
</object>";
    $bannerText = $withText && !empty($aBanner['bannertext']) ? "<br />{$anchor}{$aBanner['bannertext']}{$anchorEnd}" : '';
    // Get the image beacon...
    $beaconTag = ($logView && $conf['logging']['adImpressions']) ? _buildImageBeacon($aBanner, $zoneId, $source, $loc, $referer) : '';
    return $prepend . $code . $bannerText . $beaconTag . $append;
}

function _buildBannerCodeReal($aBanner, $zoneId=0, $source='', $ct0='', $withText=false, $logClick=true, $logView=true, $loc, $referer)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $prepend = !empty($aBanner['prepend']) ? $aBanner['prepend'] : '';
    $append = !empty($aBanner['append']) ? $aBanner['append'] : '';
    $width = !empty($aBanner['width']) ? $aBanner['width'] : 0;
    $height = !empty($aBanner['height']) ? $aBanner['height'] : 0;
    $pluginVersion = !empty($aBanner['pluginversion']) ? $aBanner['pluginversion'] : '4';
    // $imageUrlPrefix = ($_SERVER['SERVER_PORT'] == $conf['max']['sslPort']) ? $conf['type_web_ssl_url'] : $conf['type_web_url'];
    $fileName = !empty($aBanner['filename']) ? $aBanner['filename'] : '';
    $altImageBannercode = _buildBannerCodeImage($aBanner, $zoneId, $source, $ct0, false, $logClick, false, true, true, $loc, $referer);
    // Create the anchor tag..
    $clickTag = _buildClickUrl($aBanner, $source, $ct0, $logClick);
    if (!empty($clickTag)) {  // There is a link
        $status = !empty($aBanner['status']) ? " onMouseOver=\"self.status='{$aBanner['status']}'; return true;\" onMouseOut=\"self.status=''; return true;\"" : '';
        $target = !empty($aBanner['target']) ? $aBanner['target'] : '_blank';
        $swfParams = 'clickTAG=' . $clickTag;
        $anchor = "<a href='$clickTag' target='$target'$status>";
        $anchorEnd = '</a>';
    } else {
        $swfParams = '';
        $anchor = '';
        $anchorEnd = '';
    }
    $clickTag = _buildClickUrl($aBanner, $source, $ct0, $logClick);
    $fileUrl = _buildFileUrl($aBanner, false, $swfParams);
    $code = "
<object classid='clsid:CFCDAA03-8BE4-11cf-B84B-0020AFBBCCFA' width='$width' height='$height'>
<param name='src' value='$fileUrl'>
<param name='controls' value='ImageWindow'>
<param name='autostart' value='true'>
<embed src='$fileUrl' controls='ImageWindow' autostart='true' width='$width' height='$height' type='audio/x-pn-realaudio-plugin'></embed>
<noembed>$altImageBannercode</noembed>
</object>";
    $bannerText = $withText && !empty($aBanner['bannertext']) ? "<br />{$anchor}{$aBanner['bannertext']}{$anchorEnd}" : '';
    // Get the image beacon...
    $beaconTag = ($logView && $conf['logging']['adImpressions']) ? _buildImageBeacon($aBanner, $zoneId, $source, $loc, $referer) : '';
    return $prepend . $code . $bannerText . $beaconTag . $append;
}

function _buildBannerCodeHtml($aBanner, $zoneId=0, $source='', $ct0='', $withText=false, $logClick=true, $logView=true, $useAlt=false, $loc, $referer)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $prepend = !empty($aBanner['prepend']) ? $aBanner['prepend'] : '';
    $append = !empty($aBanner['append']) ? $aBanner['append'] : '';
    $code = !empty($aBanner['htmlcache']) ? $aBanner['htmlcache'] : '';

    // Parse PHP code
    if ($conf['delivery']['execPhp'])
    {
        if (preg_match ("#(\<\?php(.*)\?\>)#i", $code, $parser_regs))
        {
            // Extract PHP script
            $parser_php     = $parser_regs[2];
            $parser_result     = '';

            // Replace output function
            $parser_php = preg_replace ("#echo([^;]*);#i", '$parser_result .=\\1;', $parser_php);
            $parser_php = preg_replace ("#print([^;]*);#i", '$parser_result .=\\1;', $parser_php);
            $parser_php = preg_replace ("#printf([^;]*);#i", '$parser_result .= sprintf\\1;', $parser_php);

            // Split the PHP script into lines
            $parser_lines = explode (";", $parser_php);
            for ($parser_i = 0; $parser_i < sizeof($parser_lines); $parser_i++)
            {
                if (trim ($parser_lines[$parser_i]) != '')
                    eval (trim ($parser_lines[$parser_i]).';');
            }

            // Replace the script with the result
            $code = str_replace ($parser_regs[1], $parser_result, $code);
        }
    }

    // Get the text below the banner
    $bannerText = !empty($aBanner['bannertext']) ? "$clickTag{$aBanner['bannertext']}$clickTagEnd" : '';
    // Get the image beacon...
    if ((strpos($code, '{logurl}') === false) && (strpos($code, '{logurl_enc}') === false)) {
        $beaconTag = ($logView && $conf['logging']['adImpressions']) ? _buildImageBeacon($aBanner, $zoneId, $source, $loc, $referer) : '';
    } else {
        $beaconTag = '';
    }
    return $prepend . $code . $bannerText . $beaconTag . $append;
}

function _buildBannerCodeText($aBanner, $zoneId=0, $source='', $ct0='', $withText=false, $logClick=true, $logView=true, $useAlt=false, $loc, $referer)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $prepend = !empty($aBanner['prepend']) ? $aBanner['prepend'] : '';
    $append = !empty($aBanner['append']) ? $aBanner['append'] : '';
    // Create the anchor tag..
    $clickUrl = _buildClickUrl($aBanner, $zoneId, $source, $ct0, $logClick);
    if (!empty($clickUrl)) {  // There is a link
        $status = !empty($aBanner['status']) ? " onMouseOver=\"self.status='{$aBanner['status']}'; return true;\" onMouseOut=\"self.status=''; return true;\"" : '';
        $target = !empty($aBanner['target']) ? $aBanner['target'] : '_blank';
        $clickTag = "<a href='$clickUrl' target='$target'$status>";
        $clickTagEnd = '</a>';
    } else {
        $clickTag = '';
        $clickTagEnd = '';
    }
    // Get the text below the banner
    $bannerText = !empty($aBanner['bannertext']) ? "$clickTag{$aBanner['bannertext']}$clickTagEnd" : '';
    // Get the image beacon...
    $beaconTag = ($logView && $conf['logging']['adImpressions']) ? _buildImageBeacon($aBanner, $zoneId, $source, $loc, $referer) : '';
    return $prepend . $bannerText . $beaconTag . $append;

}

function MAX_fetchBannerDirect($what, $context = 0, $source = '', $richMedia = true)
{
    if (strpos($what, '/') !== false) {
        $aPieces = explode('/', $what);
        while (!empty($what)) {
            $aSearch[] = implode('&', $aPieces);
            unset($aPieces[sizeof($aPieces)-1]);
        }
    } else {
        $aSearch[] = $what;
    }
    foreach ($aSearch as $search) {
        $aLinkedAds = MAX_getLinkedAds($search, true, true);
        $aLinkedAd = MAX_selectAd($aLinkedAds, $context, $source, $richMedia);
        if (is_array($aLinkedAd)) {
        	$aLinkedAd['zoneid'] = 0;
			$aLinkedAd['bannerid'] = $aLinkedAd['ad_id'];
			$aLinkedAd['storagetype'] = $aLinkedAd['type'];
			$aLinkedAd['campaignid'] = $aLinkedAd['placement_id'];
			$aLinkedAd['prepend'] = '';

			return $aLinkedAd;
        }
    }

    return false;
}

function MAX_fetchBannerZone($zoneId, $context = 0, $source = '', $richMedia = true)
{
	global $phpAds_followedChain;
    global $g_append, $g_prepend;
	while (!in_array($zoneId, $phpAds_followedChain)) {
		$phpAds_followedChain[] = $zoneId;
		$appendedThisZone = false;
		// Get all ads which are linked to the zone
		$aZoneLinkedAds = MAX_getZoneLinkedAds($zoneId, true, true);
		if (is_array($aZoneLinkedAds)) {
		    if ($aZoneLinkedAds['forceappend'] == 't') {
		        $g_prepend .= $aZoneLinkedAds['prepend'];
		        $g_append = $aZoneLinkedAds['append'] . $g_append;
		        $appendedThisZone = true;
		    }
		    // Are there any ads linked to the zone?
            if ((is_array($aZoneLinkedAds['xAds']) && (count($aZoneLinkedAds['xAds']) > 0)) ||
                (is_array($aZoneLinkedAds['ads']) && (count($aZoneLinkedAds['ads']) > 0)) ||
		        (is_array($aZoneLinkedAds['lAds']) && (count($aZoneLinkedAds['lAds']) > 0))) {
		        // Get an ad from the any exclusive campaigns first...
		        $aLinkedAd = MAX_selectAd($aZoneLinkedAds, $context, $source, $richMedia, 'xAds');
		        // If no ad selected, and a previous ad on the page has set that companion ads should be selected...
                if (!is_array($aLinkedAd) && is_array($aZoneLinkedAds['zone_companion']) && is_array($context)) {
                    // Try to select a normal companion ad...
                    $aLinkedAd = MAX_selectAd($aZoneLinkedAds, $context, $source, $richMedia, 'cAds');
                    // If still no ad selected...
                    if (!is_array($aLinkedAd)) {
                        // Select one of the low-priority companion ads
                        $aLinkedAd = MAX_selectAd($aZoneLinkedAds, $context, $source, $richMedia, 'clAds');
                    }
                }
                // If still no ad selected...
                if (!is_array($aLinkedAd)) {
                    // Select one of the normal ads
                    $aLinkedAd = MAX_selectAd($aZoneLinkedAds, $context, $source, $richMedia, 'ads');
                }
                // If still no ad selected...
                if (!is_array($aLinkedAd)) {
                    // Select one of the low-priority ads
                    $aLinkedAd = MAX_selectAd($aZoneLinkedAds, $context, $source, $richMedia, 'lAds');
                }
		    	if (is_array($aLinkedAd)) {
					$aLinkedAd['zoneid'] = $zoneId;
					$aLinkedAd['bannerid'] = $aLinkedAd['ad_id'];
					$aLinkedAd['storagetype'] = $aLinkedAd['type'];
					$aLinkedAd['campaignid'] = $aLinkedAd['placement_id'];
					$aLinkedAd['zone_companion'] = $aZoneLinkedAds['zone_companion'];

					if (!$appendedThisZone) {
	                    $aLinkedAd['append'] .= $aZoneLinkedAds['append'] . $g_append;
	                    $aLinkedAd['prepend'] = $g_prepend . $aZoneLinkedAds['prepend'];
	                } else {
	                    $aLinkedAd['append'] .= $g_append;
	                    $aLinkedAd['prepend'] = $g_prepend;
	                }
					return ($aLinkedAd);
		    	}
			}
			if (!empty($aZoneLinkedAds['chain']) && (substr($aZoneLinkedAds['chain'],0,5) == 'zone:')) {
				$zoneId  = intval(substr($aZoneLinkedAds['chain'],5));
			}
		}
	}
	if (!empty($aZoneLinkedAds['default_banner_url'])) {
	    return array(
	       'default' => true,
	       'default_banner_url' =>  $aZoneLinkedAds['default_banner_url'],
	       'default_banner_dest' => $aZoneLinkedAds['default_banner_dest']
	    );
	} else {
	   return false;
	}
}

function MAX_selectAd(&$aLinkedAds, $context, $source, $richMedia, $adArrayVar = 'ads')
{
    // If there are no linked ads of the specified type, we can return
    if (count($aLinkedAds[$adArrayVar]) == 0) { return; }
	$conf = $GLOBALS['_MAX']['CONF'];

	// Build preconditions
	$excludeBannerID     = array();
	$excludeCampaignID   = array();
	$includeBannerID     = array();
	$includeCampaignID   = array();
	$companionCampaignID = array();

	if (is_array($context)) {
		for ($i=0; $i < count($context); $i++) {
		    list ($key, $value) = each($context[$i]);

			$valueArray = explode(':', $value);

			if (count($valueArray) == 1) {
                list($value) = $valueArray;
			} else {
                list($type, $value) = $valueArray;
			}

			switch($type) {
			    case 'campaignid':
    			    switch ($key) {
    			        case '!=': $excludeCampaignID[$value] = true; break;
    			        case '==': $includeCampaignID[$value] = true; break;
    			    }
    			break;
    			case 'companionid':
    			    switch ($key) {
    			        case '!=': $excludeCampaignID[$value]   = true; break;
    			        case '==': if ($adArrayVar == 'cAds') { $includeCampaignID[$value] = true; } break;
    			    }
    			break;
    			default:
        			switch ($key) {
    			        case '!=': $excludeBannerID[$value] = true; break;
    			        case '==': $includeBannerID[$value] = true; break;
    			    }
			}
		}
	}

	$prioritysum = $aLinkedAds['priority'][$adArrayVar];
	while ($prioritysum && sizeof($aLinkedAds[$adArrayVar]) > 0) {
	    $low = 0;
		$high = 0;
		if (($adArrayVar == 'ads') || ($adArrayVar == 'cAds')) {
		    // Paid campaigns have a sum of priorities of unity, so pick
		    // a random number between 0 and $prioritysum, inclusive.
            $ranweight = (mt_rand(0, MAX_RAND) / MAX_RAND) * $prioritysum;
            $paidPriorityCounter = 0;
		} else {
		    // All other campaigns have integer-based priority values, so
		    // select a random number between 0 and the sum of all the
		    // priority values
            $ranweight = ($prioritysum > 1) ? mt_rand(0, $prioritysum - 1) : 0;
		}
		// Perform selection of an ad, based on the random number
		foreach($aLinkedAds[$adArrayVar] as $adId => $aLinkedAd) {
			if (is_array($aLinkedAd)) {
				$placementId = $aLinkedAd['placement_id'];
				$low = $high;
				$high += $aLinkedAd['priority'];
				if ($high > $ranweight && $low <= $ranweight) {
				    $postconditionSuccess = true;
					// Excludelist banners
					if (isset($excludeBannerID[$adId])) {
						$postconditionSuccess = false;
					} elseif (isset($excludeCampaignID[$placementId])) {
					    // Excludelist campaigns
						$postconditionSuccess = false;
					} elseif (sizeof($includeBannerID) && !isset($includeBannerID[$adId])) {
					    // Includelist banners
						$postconditionSuccess = false;
					} elseif (sizeof($includeCampaignID) && !isset($includeCampaignID[$placementId])) {
					    // Includelist campaigns
						$postconditionSuccess = false;
					} elseif (   // Exclude richmedia banners if no alt image is specified
					             $richMedia == false &&
					             $aLinkedAd['alt_filename'] == '' &&
					             !($aLinkedAd['contenttype'] == 'jpeg' || $aLinkedAd['contenttype'] == 'gif' || $aLinkedAd['contenttype'] == 'png') &&
					             !($aLinkedAd['type'] == 'url' && $aLinkedAd['contenttype'] == '')
					         ) {
					    $postconditionSuccess = false;
					} elseif (phpAds_isAdBlocked($adId, $aLinkedAd['block'])) {
					    // Blocked
						$postconditionSuccess = false;
					} elseif (phpAds_isAdCapped($adId, $aLinkedAd['capping'], $aLinkedAd['session_capping'])) {
					    // Capped
						$postconditionSuccess = false;
					} elseif ($_SERVER['SERVER_PORT'] == 443 && $aLinkedAd['type'] == 'html' && strpos($aLinkedAd['htmlcache'],'http:') >= 0 ) {
					    // HTML Banners that contain 'http:' on SSL
						$postconditionSuccess = false;
					} elseif ($_SERVER['SERVER_PORT'] == 443 && $aLinkedAd['type'] == 'url' && is_numeric(strpos($aLinkedAd['url'],'http:'))) {
					    // External Banners that contain 'http:' on SSL
					    // Note: Using "is_numeric" because usual value will be 0 (first character in string) but may be preceeded by spaces
						$postconditionSuccess = false;
					} elseif ($conf['delivery']['acls'] && !MAX_checkAcl($aLinkedAd, $source)) {
						$postconditionSuccess = false;
					}
					// If $postconditionSuccess is true, we can select this ad, otherwise,
					// the ad cannot be shown, and we need to throw the ad out...
					if ($postconditionSuccess) {
						return $aLinkedAd;
					} else {
						// Delete this row and adjust $prioritysum
						$prioritysum -= $aLinkedAd['priority'];
						unset($aLinkedAds[$adArrayVar][$adId]);
						// Break out of the for loop to try again
						break;
					}
				} else {
				    // This ad did not match the random value generated. If we
				    // are also looking for a paid placement ad, count the number
				    // of iterations (ads we have looked at), so that we know
				    // when we have selected the blank ad
				    if (($adArrayVar == 'ads') || ($adArrayVar == 'cAds')) {
				        $paidPriorityCounter++;
				    }
				    // Have we tested all the ads yet?
				    if ($paidPriorityCounter == count($aLinkedAds[$adArrayVar])) {
				        // Yes, and no ad was suitable, so no paid ad should be shown
				        return;
				    }
				}
			}
		}
	}
}

/*-------------------------------------------------------*/
/* Check if the ACL is valid                             */
/*-------------------------------------------------------*/
function MAX_checkAcl($row, $source)
{
    if (!empty($row['compiledlimitation'])) {
        // Set to true in case of error in eval
        $result = true;

        // Include required delivery files...
        if(strlen($row['acl_plugins'])) {
            $acl_plugins = explode(',', $row['acl_plugins']);
            foreach ($acl_plugins as $acl_plugin) {
                list($package, $name) = explode(':', $acl_plugin);
                require_once(MAX_PATH . "/plugins/deliveryLimitations/{$package}/{$name}.delivery.php");
            }
        }

        @eval('$result = (' . $row['compiledlimitation'] . ');');
        return $result;
    } else {
        return true;
    }
}

?>
