<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2006 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: default.plugin.php 4769 2006-05-02 15:12:12Z matteo@beccati.com $
*/

/**
 * @package    MaxPlugins
 * @subpackage StatsFields
 * @author     Matteo Beccati <matteo@beccati.com>
 */

require_once MAX_PATH . '/plugins/statsFields/statsFields.php';
require_once MAX_PATH . '/lib/max/Plugin/Translation.php';

/**
 * Stats fields plugin
 *
 * @package    MaxPlugins
 * @subpackage Plugins_StatsFields
 * @author     Matteo Beccati <matteo@beccati.com>
 * @abstract
 */
class Plugins_StatsFields_default_default extends Plugins_StatsFields
{
    /**
     * Constructor
     */
    function Plugins_StatsFields_default_default() {
        // Set module and package because they aren't set when running the constructor method
        $this->module  = 'statsFields';
        $this->package = 'default';
        
        $this->_fields = array(
            'sum_requests'     => array('name' => MAX_Plugin_Translation::translate('Req.', $this->module, $this->package),
                                        'format' => 'default'),
            'sum_views'        => array('name' => MAX_Plugin_Translation::translate('Impr.', $this->module, $this->package),
                                        'format' => 'default'),
            'sum_clicks'       => array('name' => MAX_Plugin_Translation::translate('Clicks', $this->module, $this->package),
                                        'format' => 'default'),
            'sum_ctr'          => array('name' => MAX_Plugin_Translation::translate('CTR', $this->module, $this->package),
                                        'format' => 'percent'),
            'sum_conversions'  => array('name' => MAX_Plugin_Translation::translate('Conv.', $this->module, $this->package),
                                        'format' => 'default', 'link' => 'stats-conversions.php?'),
            'sum_sr'           => array('name' => MAX_Plugin_Translation::translate('Click SR', $this->module, $this->package),
                                        'format' => 'percent')
        );
        $this->_prefs = array(
            'sum_requests'     => array('name' => MAX_Plugin_Translation::translate('Show Requests column', $this->module, $this->package),
                                        'var' => 'gui_show_requests'),
            'sum_views'        => array('name' => MAX_Plugin_Translation::translate('Show Impressions column', $this->module, $this->package),
                                        'var' => 'gui_show_impressions'),
            'sum_clicks'       => array('name' => MAX_Plugin_Translation::translate('Show Clicks column', $this->module, $this->package),
                                        'var' => 'gui_show_clicks'),
            'sum_ctr'          => array('name' => MAX_Plugin_Translation::translate('Show CTR column', $this->module, $this->package),
                                        'var' => 'gui_show_ctr'),
            'sum_conversions'  => array('name' => MAX_Plugin_Translation::translate('Show Conversions column', $this->module, $this->package),
                                        'var' => 'gui_show_conversions'),
            'sum_sr'           => array('name' => MAX_Plugin_Translation::translate('Show Click SR column', $this->module, $this->package),
                                        'var' => 'gui_show_sr')
        );
    }

    /**
     * Return name of plugin
     *
     * @abstract
     * @return string A string describing the class.
     */
    function getName()
    {
        return 'Default columns';
    }

    /**
     * Generate CTR and SR ratios
     *
     * @static
     *
     * @param array Row of stats
     */
    function summarizeStats(&$row)
    {
        $row['sum_ctr'] = $row['sum_views']  ? $row['sum_clicks'] / $row['sum_views'] : 0;
        $row['sum_sr']  = $row['sum_clicks'] ? $row['sum_conversions'] / $row['sum_clicks'] : 0;
    }
}

?>
